HDU 1069 Monkey and Banana (动规)

Monkey and Banana

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 7248    Accepted Submission(s): 3730

Problem Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall
be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions
of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly
smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn‘t be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n,

representing the number of different blocks in the following data set. The maximum value for n is 30.

Each of the next n lines contains three integers representing the values xi, yi and zi.

Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".

Sample Input

1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0

Sample Output

Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342

Source

University of Ulm Local Contest 1996

Recommend

JGShining   |   We have carefully selected several similar problems for you:  1176 1058 1159 2084 1024

题意:

有一堆箱子,有长宽高,x,y,z。  规定:放在上面的箱子,无论长和宽都要比下面的箱子大,只有一边大是不行的。

箱子的方向可以任意放。 这样,x,y,z就有六种组合。其实也可以说是三种(如果要的是面积的大小)。

因为要和上面的箱子比较,这里为了计算方便,直接写成六种。

求的是最大高度。

注意:不是只有一个箱子,而是很多那种规格的箱子,开始以为只有一个,第一个样例就不能解释。

只不过这个情况,我们需要先排下序。把大的箱子放前面。有点牵强的说,也算是用了贪心的思想。

虽然我们不能确定一个x边最大的箱子不一定就能放在最下面,例如的它的y边很小,但是,它肯定也放不到其它箱子的上面,所以,把它放前面也是可以的。

因此可以按x边排序。不过在最后比较的时候,要严格遵循 x1 > x2 && y1 > y2。

#include <iostream>
#include <algorithm>
using namespace std;
#define M 1000
struct node
{
    int x,y,z;
}vis[M];
int mat[M];
bool cmp(node a,node b)
{
    if(a.x==b.x)
        return a.y>b.y;
    return a.x>b.x;
}

int main(int a,int b,int c)
{
    int i,j,n,k=0;
    while(scanf("%d",&n)!=EOF&&n)
    {   memset(mat,0,sizeof(mat));
        k++;
        for(i=0;i<n*6;i+=6)
        {   //箱子的不同放法。
            scanf("%d%d%d",&a,&b,&c);
            {
                vis[i].x=a;
                vis[i].y=b;
                vis[i].z=c;

                vis[i+1].x=a;
                vis[i+1].y=c;
                vis[i+1].z=b;

                vis[i+2].x=b;
                vis[i+2].y=a;
                vis[i+2].z=c;

                vis[i+3].x=b;
                vis[i+3].y=c;
                vis[i+3].z=a;

                vis[i+4].x=c;
                vis[i+4].y=a;
                vis[i+4].z=b;

                vis[i+5].x=c;
                vis[i+5].y=b;
                vis[i+5].z=a;
            }
        }
            sort(vis,vis+n*6,cmp); //排序。
            for(i=0;i<n*6;i++)
            {
                mat[i]=vis[i].z;     //初始情况:只有自己,下面没有垫箱子。
                for(j=i-1;j>=0;j--)  //从i->0和0->i都可以,因为mat[j]就是第j个箱子在最上面的最优解,这个在循环里已经求过。
                {
                    if(vis[i].x<vis[j].x&&vis[i].y<vis[j].y)
                        if(mat[i]<mat[j]+vis[i].z)           //找到一个更优解,替换掉原来的解。
                        {
                            mat[i]=mat[j]+vis[i].z;
                        }
                }
            }
            int max=0;
            for(i=0;i<n*6;i++)
            if(max<mat[i]) max=mat[i];             //寻找每一个箱子在最上面的时候的高度最大值。
            printf("Case %d: maximum height = %d\n",k,max);
    }
    return 0;
}

HDU 1069 Monkey and Banana (动规)

时间: 2024-08-01 10:44:19

HDU 1069 Monkey and Banana (动规)的相关文章

[2016-03-30][HDU][1069][Monkey and Banana]

时间:2016-03-27 15:19:40 星期日 题目编号:[2016-03-30][HDU][1069][Monkey and Banana] 题目大意:给定n种积木无限个,问这些积木最大能叠多高,上面的积木长宽必须严格小于下面的积木 分析: dp[i]表示第i个积木在顶部时候的最大高度,那么dp[i] = max(dp[i],dp[j] + h[i]);?ji能放在j上面?ji能放在j上面 初始条件就是长宽最大的高度是它自己, #include <algorithm> #include

HDU 1069 Monkey and Banana(DP 长方体堆放问题)

Monkey and Banana Problem Description A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever

HDU 1069 Monkey and Banana dp 题解

HDU 1069 Monkey and Banana 题解 纵有疾风起 题目大意 一堆科学家研究猩猩的智商,给他M种长方体,每种N个.然后,将一个香蕉挂在屋顶,让猩猩通过 叠长方体来够到香蕉. 现在给你M种长方体,计算,最高能堆多高.要求位于上面的长方体的长要大于(注意不是大于等于)下面长方体的长,上面长方体的宽大于下面长方体的宽. 输入输出 开始一个数n,表示有多少种木块,木块的数量无限,然后接下来的n行,每行3个数,是木块的长宽高三个参量 输出使用这些在满足条件的情况下能够摆放的最大高度 解

HDU 1069 Monkey and Banana(二维偏序LIS的应用)

---恢复内容开始--- Monkey and Banana Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 13003    Accepted Submission(s): 6843 Problem Description A group of researchers are designing an experiment to te

HDU 1069 Monkey and Banana 基础DP

题目链接:Monkey and Banana 大意:给出n种箱子的长宽高.每种不限个数.可以堆叠.询问可以达到的最高高度是多少. 要求两个箱子堆叠的时候叠加的面.上面的面的两维长度都严格小于下面的. 简单的DP,依然有很多地发给当时没想到.比如优先级,比如这么简单粗暴的选择. 1 /* 2 大意是.给出n种箱子的长宽高.每种不限个数.可以堆叠.询问可以达到的最高高度是多少. 3 要求两个箱子堆叠的时候叠加的面.上面的面的两维长度都严格小于下面的. 4 5 样例: 6 10 20 30 7 10

HDU 1069 Monkey and Banana LCS变形

点击打开链接题目链接 Monkey and Banana Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7617    Accepted Submission(s): 3919 Problem Description A group of researchers are designing an experiment to test

hdu 1069 Monkey and Banana (结构体排序,也属于简单的dp)

Monkey and Banana Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7770    Accepted Submission(s): 4003 Problem Description A group of researchers are designing an experiment to test the IQ of a

DP [HDU 1069] Monkey and Banana

Monkey and Banana Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 7854    Accepted Submission(s): 4051 Problem Description A group of researchers are designing an experiment to test the IQ of a

HDU 1069 Monkey and Banana(最大的单调递减序列啊 dp)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1069 Problem Description A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with so